<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>StereotypeApplicationWithVSLProposalProvider xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../../apidocs/org/eclipse/papyrus/marte/textedit/stereotypeapplicationwithvsl/xtext/ui/contentassist/StereotypeApplicationWithVSLProposalProvider.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2010, 2016 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  CEA LIST - Initial API and implementation</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.marte.textedit.stereotypeapplicationwithvsl.xtext.ui.contentassist;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.HashMap;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> java.util.Map;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EClass;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EObject;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.text.contentassist.ICompletionProposal;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.textedit.stereotypeapplicationwithvsl.xtext.stereotypeApplicationWithVSL.StereotypeApplicationRule;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.textedit.stereotypeapplicationwithvsl.xtext.stereotypeApplicationWithVSL.TagSpecificationRule;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.ui.contentassist.VSLProposalUtils;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.xtext.integration.CompletionProposalUtils;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TypedElement;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.Assignment;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.ui.editor.contentassist.ContentAssistContext;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.ui.editor.contentassist.ICompletionProposalAcceptor;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <em class="jxr_javadoccomment"> * see <a href="http://www.eclipse.org/Xtext/documentation/latest/xtext.html" target="alexandria_uri">http://www.eclipse.org/Xtext/documentation/latest/xtext.html</a>#contentAssist on how to customize content assistant</em>
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../../org/eclipse/papyrus/marte/textedit/stereotypeapplicationwithvsl/xtext/ui/contentassist/StereotypeApplicationWithVSLProposalProvider.html">StereotypeApplicationWithVSLProposalProvider</a> <strong class="jxr_keyword">extends</strong> AbstractStereotypeApplicationWithVSLProposalProvider {
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  	@Override
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> completeTagSpecificationRule_Property(EObject model, Assignment assignment, ContentAssistContext context, ICompletionProposalAcceptor acceptor) {
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  		List&lt;NamedElement&gt; visibleProperties = getVisibleProperties(model);
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  		visibleProperties = <strong class="jxr_keyword">this</strong>.sortByKindAndName(visibleProperties);
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  		<strong class="jxr_keyword">for</strong> (EObject o : visibleProperties) {
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  			NamedElement namedElement = (NamedElement) o;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  			<strong class="jxr_keyword">if</strong> (namedElement.getName().toLowerCase().contains(context.getPrefix().toLowerCase())) {
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  				String completionString = context.getPrefix() + namedElement.getName().substring(context.getPrefix().length()) + <span class="jxr_string">" = "</span>;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  				String displayString = namedElement.getName();
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  				<strong class="jxr_keyword">if</strong> (namedElement instanceof TypedElement) {
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  					TypedElement typedElement = (TypedElement) namedElement;
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  					displayString += typedElement.getType() != <strong class="jxr_keyword">null</strong> ? <span class="jxr_string">" : "</span> + typedElement.getType().getName() : <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  				}
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  				ICompletionProposal completionProposal = CompletionProposalUtils.createCompletionProposalWithReplacementOfPrefix(namedElement, completionString, displayString, context);
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  				acceptor.accept(completionProposal);
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  			}
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  		}
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  	}
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  	<strong class="jxr_keyword">private</strong> List&lt;NamedElement&gt; getVisibleProperties(EObject rule) {
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  		List&lt;NamedElement&gt; visibleProperties = <strong class="jxr_keyword">new</strong> ArrayList&lt;NamedElement&gt;();
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  		<em class="jxr_comment">// first retrieves the context stereotype</em>
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  		EObject context = rule;
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  		<strong class="jxr_keyword">while</strong> (context != <strong class="jxr_keyword">null</strong> &amp;&amp; !(context instanceof StereotypeApplicationRule)) {
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  			context = context.eContainer();
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  		}
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  		<strong class="jxr_keyword">if</strong> (context != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  			<em class="jxr_comment">// retrieves the stereotype which is applied</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  			StereotypeApplicationRule stAppRule = (StereotypeApplicationRule) context;
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  			<strong class="jxr_keyword">if</strong> (stAppRule.getStereotype() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  				<em class="jxr_comment">// add all the available properties for this stereotype</em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  				visibleProperties.addAll(stAppRule.getStereotype().getAllAttributes());
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  				<em class="jxr_comment">// removes derived properties or those which name starts with "base_"</em>
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  				List&lt;Property&gt; filteredList = <strong class="jxr_keyword">new</strong> ArrayList&lt;Property&gt;(stAppRule.getStereotype().getAllAttributes());
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  				<strong class="jxr_keyword">for</strong> (Property p : filteredList) {
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  					<strong class="jxr_keyword">if</strong> (p.getName() == <strong class="jxr_keyword">null</strong> || p.getName().startsWith(<span class="jxr_string">"base_"</span>) || p.isDerived()) {
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  						visibleProperties.remove(p);
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  					}
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  				}
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  				<em class="jxr_comment">// removes the ones which have already been used</em>
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  				<strong class="jxr_keyword">if</strong> (stAppRule.getTagSpecification() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  					<strong class="jxr_keyword">for</strong> (TagSpecificationRule tag : stAppRule.getTagSpecification()) {
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  						<strong class="jxr_keyword">if</strong> (tag.getProperty() != <strong class="jxr_keyword">null</strong> &amp;&amp; visibleProperties.contains(tag.getProperty())) {
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  							visibleProperties.remove(tag.getProperty());
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  						}
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  					}
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  				}
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  			}
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  		}
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  		<strong class="jxr_keyword">return</strong> visibleProperties;
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  	}
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  	@Override
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> completeExpressionValueRule_Expression(EObject model, Assignment assignment, ContentAssistContext context, ICompletionProposalAcceptor acceptor) {
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  		<strong class="jxr_keyword">if</strong> (model.eContainer() == <strong class="jxr_keyword">null</strong> || !(model.eContainer() instanceof TagSpecificationRule)) {
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  			<strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  		}
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  		TagSpecificationRule tagSpecificationRule = (TagSpecificationRule) model.eContainer();
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 		<strong class="jxr_keyword">if</strong> (tagSpecificationRule.getProperty() == <strong class="jxr_keyword">null</strong> || tagSpecificationRule.getProperty().getType() == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 			<strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 		}
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 		Property p = tagSpecificationRule.getProperty();
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		Map&lt;String, Element&gt; allProposals = VSLProposalUtils.buildProposalForType((Classifier) p.getType(), p);
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 		<em class="jxr_comment">// List&lt;String&gt; allProposals = ProposalUtils.buildProposalForType((Classifier)p.getType()) ;</em>
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 		<strong class="jxr_keyword">for</strong> (String s : allProposals.keySet()) {
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 			String completionString = s.substring(context.getPrefix().length());
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 			String displayString = s;
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 			ICompletionProposal completionProposal = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 			<strong class="jxr_keyword">if</strong> (allProposals.get(s) == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 				completionString = s.substring(context.getPrefix().length());
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 				displayString = s;
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 				completionProposal = CompletionProposalUtils.createCompletionProposal(completionString, displayString, context);
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 				acceptor.accept(completionProposal);
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 				<strong class="jxr_keyword">if</strong> (!s.contains(<span class="jxr_string">"|"</span>)) {
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 					displayString = s;
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 					completionString = s;
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 				} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 					completionString = s.substring(0, s.indexOf(<span class="jxr_string">"|"</span>));
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 					displayString = s.substring(s.indexOf(<span class="jxr_string">"|"</span>) + 1);
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 				}
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 				<strong class="jxr_keyword">if</strong> (displayString.contains(context.getPrefix())) {
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 					completionProposal = CompletionProposalUtils.createCompletionProposalWithReplacementOfPrefix((NamedElement) allProposals.get(s), completionString, displayString, context);
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 					acceptor.accept(completionProposal);
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 				}
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 			}
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 		}
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 		<em class="jxr_comment">// super.completeExpressionValueRule_Expression(model, assignment, context,</em>
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 		<em class="jxr_comment">// acceptor);</em>
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 	}
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 	<em class="jxr_comment">/* *************************************************</em>
<a class="jxr_linenumber" name="L138" href="#L138">138</a> <em class="jxr_comment">	 *</em>
<a class="jxr_linenumber" name="L139" href="#L139">139</a> <em class="jxr_comment">	 * Private utility method for sorting a list of NamedElement by kind and name</em>
<a class="jxr_linenumber" name="L140" href="#L140">140</a> <em class="jxr_comment">	 *</em>
<a class="jxr_linenumber" name="L141" href="#L141">141</a> <em class="jxr_comment">	 * ************************************************</em>
<a class="jxr_linenumber" name="L142" href="#L142">142</a> <em class="jxr_comment">	 */</em>
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 	<strong class="jxr_keyword">protected</strong> List&lt;NamedElement&gt; sortByKindAndName(List&lt;NamedElement&gt; list) {
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 		List&lt;NamedElement&gt; sortedList = <strong class="jxr_keyword">new</strong> ArrayList&lt;NamedElement&gt;();
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 		HashMap&lt;EClass, List&lt;NamedElement&gt;&gt; namedElementGroups = <strong class="jxr_keyword">new</strong> HashMap&lt;EClass, List&lt;NamedElement&gt;&gt;();
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 		<strong class="jxr_keyword">for</strong> (NamedElement n : list) {
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 			<strong class="jxr_keyword">if</strong> (!namedElementGroups.containsKey(n.eClass())) {
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 				List&lt;NamedElement&gt; group = <strong class="jxr_keyword">new</strong> ArrayList&lt;NamedElement&gt;();
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 				group.add(n);
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 				namedElementGroups.put(n.eClass(), group);
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 				List&lt;NamedElement&gt; group = namedElementGroups.get(n.eClass());
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 				<strong class="jxr_keyword">boolean</strong> inserted = false;
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 				<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; inserted == false &amp;&amp; i &lt; group.size(); i++) {
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 					<strong class="jxr_keyword">if</strong> (group.get(i).getName().compareTo(n.getName()) &gt; 0) {
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 						group.add(i, n);
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 						inserted = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 					}
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 				}
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 				<strong class="jxr_keyword">if</strong> (!inserted) {
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 					group.add(n);
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 				}
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 				namedElementGroups.put(n.eClass(), group);
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 			}
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 		}
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 		<strong class="jxr_keyword">for</strong> (EClass c : namedElementGroups.keySet()) {
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 			List&lt;NamedElement&gt; group = namedElementGroups.get(c);
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 			sortedList.addAll(group);
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 		}
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 		<strong class="jxr_keyword">return</strong> sortedList;
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 	}
<a class="jxr_linenumber" name="L176" href="#L176">176</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
